#coding=UTF-8
import synthDriverHandler, winUser, ctypes, threading, os, win32api, addonHandler
from synthDriverHandler import SynthDriver,VoiceInfo
from ctypes import *
from collections import OrderedDict
addonHandler.initTranslation()

lastIndex = 0
isPlaying = False
eci_vc =None 
eci = None
user32 = windll.user32
tid = None
#stopped = threading.Event()
#started = threading.Event()
class eciThread(threading.Thread):
 def run(self):
  global tid
  tid = windll.kernel32.GetCurrentThreadId()
  msg = wintypes.MSG()
  user32.PeekMessageA(byref(msg), None, 0x400, 0x400, 0)
#  started.set()
  while True:
   user32.GetMessageA(byref(msg), 0, 0, 0)
   user32.TranslateMessage(byref(msg))
#   if msg.message == 1199:
#    nvwave.playWaveFile("waves\\start.wav")
   if msg.message == 1200:
    global lastIndex, isPlaying
    lastIndex = msg.wParam
    isPlaying = False
   else:
    user32.DispatchMessageA(byref(msg))
class COPYDATA(Structure):
 _fields_ = [
    ("dwData", c_ulong),
    ("cbData", c_ulong),
    ("lpData", c_void_p)
    ]
CopyData = COPYDATA()
CopyData.dwData = 1

class SynthDriver(synthDriverHandler.SynthDriver):
 supportedSettings=(SynthDriver.VoiceSetting(),SynthDriver.RateSetting(),SynthDriver.PitchSetting(),SynthDriver.InflectionSetting(),SynthDriver.VolumeSetting())
 description='eci_vc'
 name='eci_vc'
 @classmethod
 def check(cls):
  return True
 def __init__(self):
  global eci_vc, eci
  curexe = os.path.join(os.path.dirname(__file__), r"eci_vvtts_vc.exe")
  win32api.WinExec(curexe, 5)
  eci_vc = winUser.FindWindow(u"chenfu2014", u"eci_vvtts_vc")
  eci = eciThread()
  eci.setDaemon(True)
  eci.start()
##  started.wait()
#  started.clear()
  self.voice = '5'
  self.rate=60
  self.pitch = 70
  self.inflection = 30
  self.volume = 100

 def speakText(self,text,index=None):
  global isPlaying
  if index == None:
   vcData = 0
  else:
   vcData = index
  isPlaying = True
  text = text.encode('mbcs')
  buf = c_buffer(text)
  blen = sizeof(buf)
  ptr = windll.kernel32.GlobalAlloc(0x40, blen)
  cdll.msvcrt.memcpy(ptr, ctypes.addressof(buf), blen)
  CopyData.dwData = vcData
  CopyData.cbData = blen
  CopyData.lpData = ptr
#  winUser.sendMessage.argtypes = [c_int, c_int, c_int,POINTER(COPYDATA)];
  winUser.sendMessage(eci_vc, 74, tid, byref(CopyData))

 def cancel(self):
  global isPlaying
  isPlaying = False
  winUser.PostMessage(eci_vc, 1235, 0, 0)

 def pause(self,switch):
  winUser.PostMessage(eci_vc, 1235, 0, 0)

 def terminate(self):
  winUser.sendMessage(eci_vc, 0x0002, 0, 0)

 def _getAvailableVoices(self):
  return OrderedDict([('1', VoiceInfo('1', _('Adult Male 1'))),
         ('2', VoiceInfo('2', _('Adult Female 1'))),
         ('3', VoiceInfo('3', _('Child 1'))),
         ('4', VoiceInfo('4', _('Adult Male 2'))),
         ('5', VoiceInfo('5', _('Adult Male 3'))),
         ('6', VoiceInfo('6', _('Adult Female 2'))),
         ('7', VoiceInfo('7', _('Elderly Female 1'))),
         ('8', VoiceInfo('8', _('Elderly Male 1')))])

 def _get_voice(self):
  return self.oldVoice

 def _set_voice(self, voice):
  self.oldVoice = voice
  SetVoice(voice)

 def _get_rate(self):
  return self.oldRate

 def _set_rate(self, rate):
  self.oldRate = rate
  value = self._percentToParam(rate, 0, 200)
  winUser.PostMessage(eci_vc, 1234, 6, value)

 def _get_pitch(self):
  return self.oldPitch

 def _set_pitch(self,pitch):
  self.oldPitch = pitch
  value = self._percentToParam(pitch, 0, 100)
  winUser.PostMessage(eci_vc, 1234, 2, value)

 def _get_volume(self):
  return self.oldVolume

 def _set_volume(self,volume):
  self.oldVolume = volume
  value = self._percentToParam(volume, 0, 100)
  winUser.PostMessage(eci_vc, 1234, 7, value)

 def _set_inflection(self,inflection):
  self.oldInflection = inflection
  value = self._percentToParam(inflection, 0, 100)
  winUser.PostMessage(eci_vc, 1234, 3, value)

 def _get_inflection(self):
  return self.oldInflection

 def _get_lastIndex(self):
  return lastIndex

 def _get_busy(self):
  return isPlaying

def SetVoice(voice):
	if voice == '1':
		winUser.PostMessage(eci_vc, 1236, 1, 0)
	if voice == '2':
		winUser.PostMessage(eci_vc, 1236, 2, 0)
	if voice == '3':
		winUser.PostMessage(eci_vc, 1236, 3, 0)
	if voice == '4':
		winUser.PostMessage(eci_vc, 1236, 4, 0)
	if voice == '5':
		winUser.PostMessage(eci_vc, 1236, 5, 0)
	if voice == '6':
		winUser.PostMessage(eci_vc, 1236, 6, 0)
	if voice == '7':
		winUser.PostMessage(eci_vc, 1236, 7, 0)
	if voice == '8':
		winUser.PostMessage(eci_vc, 1236, 8, 0)